<?php
/**
 * @author 1902 Software
 * @copyright Copyright © 2023 1902 Software (https://1902software.com/magento/)
 * @package WriteTextAI_WriteTextAI
 */

declare(strict_types=1);

namespace WriteTextAI\WriteTextAI\Api;

use Magento\Framework\Api\SearchCriteriaInterface;
use WriteTextAI\WriteTextAI\Api\Data\ProductKeywordCompetitorFiltersInterface;

interface ProductKeywordCompetitorFiltersRepositoryInterface
{

    /**
     * Save ProductKeywordCompetitorFilters
     *
     * @param ProductKeywordCompetitorFiltersInterface $productKeywordCompetitorFilters
     * @return ProductKeywordCompetitorFiltersInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function save(
        ProductKeywordCompetitorFiltersInterface $productKeywordCompetitorFilters
    );

    /**
     * Retrieve ProductKeywordCompetitorFilters
     *
     * @param string $productkeywordcompetitorfiltersId
     * @return ProductKeywordCompetitorFiltersInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function get($productkeywordcompetitorfiltersId);

    /**
     * Retrieve ProductKeywordCompetitorFilters matching the specified criteria.
     *
     * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
     * @return \WriteTextAI\WriteTextAI\Api\Data\ProductKeywordCompetitorFiltersSearchResultsInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getList(
        \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
    );

    /**
     * Delete ProductKeywordCompetitorFilters
     *
     * @param ProductKeywordCompetitorFiltersInterface $productKeywordCompetitorFilters
     * @return bool true on success
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function delete(
        ProductKeywordCompetitorFiltersInterface $productKeywordCompetitorFilters
    );

    /**
     * Delete ProductKeywordCompetitorFilters by ID
     *
     * @param string $productkeywordcompetitorfiltersId
     * @return bool true on success
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function deleteById($productkeywordcompetitorfiltersId);
}
