<?php
/**
 * @author 1902 Software
 * @copyright Copyright © 2023 1902 Software (https://1902software.com/magento/)
 * @package WriteTextAI_WriteTextAI
 */

declare(strict_types=1);

namespace WriteTextAI\WriteTextAI\Api;

use Magento\Framework\Api\SearchCriteriaInterface;

interface ProductKeywordRankedFiltersRepositoryInterface
{
    /**
     * Save ProductKeywordRankedFilters
     *
     * @param \WriteTextAI\WriteTextAI\Api\Data\ProductKeywordRankedFiltersInterface $productKeywordRankedFilters
     * @return \WriteTextAI\WriteTextAI\Api\Data\ProductKeywordRankedFiltersInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function save(
        \WriteTextAI\WriteTextAI\Api\Data\ProductKeywordRankedFiltersInterface $productKeywordRankedFilters
    );

    /**
     * Retrieve ProductKeywordRankedFilters
     *
     * @param string $productkeywordrankedfiltersId
     * @return \WriteTextAI\WriteTextAI\Api\Data\ProductKeywordRankedFiltersInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function get($productkeywordrankedfiltersId);

    /**
     * Retrieve ProductKeywordRankedFilters matching the specified criteria.
     *
     * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
     * @return \WriteTextAI\WriteTextAI\Api\Data\ProductKeywordRankedFiltersSearchResultsInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getList(
        \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
    );

    /**
     * Delete ProductKeywordRankedFilters
     *
     * @param \WriteTextAI\WriteTextAI\Api\Data\ProductKeywordRankedFiltersInterface $productKeywordRankedFilters
     * @return bool true on success
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function delete(
        \WriteTextAI\WriteTextAI\Api\Data\ProductKeywordRankedFiltersInterface $productKeywordRankedFilters
    );

    /**
     * Delete ProductKeywordRankedFilters by ID
     *
     * @param string $productkeywordrankedfiltersId
     * @return bool true on success
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function deleteById($productkeywordrankedfiltersId);
}
