/**
 * @author 1902 Software
 * @copyright Copyright © 2023 1902 Software (https://1902software.com/magento/)
 * @package WriteTextAI_WriteTextAI
 */

define(['ko', 'domReady!'], function (ko) {
    'use strict';

    var targetKeywords = ko.observableArray([]),
        selectedSemanticKeywords = ko.observableArray([]),
        highlighted = ko.observable(true),
        language = ko.observable(),
        country = ko.observable(),
        location = ko.observable(),
        suggestedKeywords = ko.observableArray([]),
        myRanking = ko.observable({}),
        competitorRanking = ko.observable({}),
        manualInput = ko.observableArray([]),
        serpDate = ko.observable(''),
        errorMessage = ko.observable(''),
        successMessage = ko.observable(''),
        totalPages = ko.observable(0),
        keywordsChangeOngoing = ko.observable(false),
        ideasShowMoreOngoing = ko.observable(false),
        ideasSortFilterOngoing = ko.observable(false),
        fetchingData = ko.observable(false),
        manualKeywordsChangeOngoing = ko.observable(false),
        showSelectedRefresh = ko.observable(false),
        showCompetitorRefresh = ko.observable(false),
        showIdeasRefresh = ko.observable(false),
        showRankedRefresh = ko.observable(false),
        rankedDate = ko.observable(''),
        competitorDate = ko.observable(''),
        ideasDate = ko.observable(''),
        initialized = ko.observable(false),
        stale = ko.observable(false),
        newKeywordExists = ko.observable(false),
        newTargetExists = ko.observable(false),
        targetRemoved = ko.observable(false),
        needRefresh = ko.observable(false);

    return {
        targetKeywords: targetKeywords,
        selectedSemanticKeywords: selectedSemanticKeywords,
        highlighted: highlighted,
        language: language,
        country: country,
        location: location,
        suggestedKeywords: suggestedKeywords,
        myRanking: myRanking,
        competitorRanking: competitorRanking,
        manualInput: manualInput,
        serpDate: serpDate,
        errorMessage: errorMessage,
        successMessage: successMessage,
        totalPages: totalPages,
        keywordsChangeOngoing: keywordsChangeOngoing,
        ideasShowMoreOngoing: ideasShowMoreOngoing,
        ideasSortFilterOngoing: ideasSortFilterOngoing,
        fetchingData: fetchingData,
        manualKeywordsChangeOngoing: manualKeywordsChangeOngoing,
        showSelectedRefresh: showSelectedRefresh,
        showCompetitorRefresh: showCompetitorRefresh,
        showIdeasRefresh: showIdeasRefresh,
        showRankedRefresh: showRankedRefresh,
        rankedDate: rankedDate,
        competitorDate: competitorDate,
        ideasDate: ideasDate,
        initialized: initialized,
        stale: stale,
        newKeywordExists: newKeywordExists,
        newTargetExists: newTargetExists,
        targetRemoved: targetRemoved,
        needRefresh: needRefresh
    };
});
